import React from "react";
import {
  LanguageContext,
  languages,
} from "../component/Language/LanguageContext";

const list = {
  german: [
    {
      name: "Privat",
      description: "Privates Projekt",
      language: "GoLang",
      date: "05/2021 - jetzt",
    },
    {
      link: "https://gitea.roese.dev/Alex/personal-website",
      name: "Diese Webseite",
      description: "Privates Projekt",
      language: "React.js, JavaScript, CSS, HTML, GoLang",
      date: "07/2021",
    },
    {
      link: "https://github.com/RuisPipe/PasswordManager",
      name: "Password Manager",
      description: "Eigener Passwortmanager",
      language: "JavaScript, CSS, HTML, Node.JS",
      date: "03/2020 - 12/2020",
    },
  ],
  english: [
    {
      name: "Private",
      description: "Private project",
      language: "GoLang",
      date: "05/2021 - now",
    },
    {
      link: "https://gitea.roese.dev/Alex/personal-website",
      name: "This website",
      description: "Private project",
      language: "React.js, JavaScript, CSS, HTML, GoLang",
      date: "07/2021",
    },
    {
      link: "https://github.com/RuisPipe/PasswordManager",
      name: "Password Manager",
      description: "Self-hosted encrypted password manager",
      language: "JavaScript, CSS, HTML, Node.JS",
      date: "03/2020 - 12/2020",
    },
  ],
};

function RenderProjects(props) {
  if (props.language === languages.german) {
    return list.german.map((project, index) => (
      <tr key={"a" + index}>
        <td key={"b" + index}>
          <a href={project.link}>{project.name}</a>
        </td>
        <td key={"c" + index}>{project.description}</td>
        <td key={"d" + index}>{project.language}</td>
        <td key={"e" + index}>{project.date}</td>
      </tr>
    ));
  }

  return list.english.map((project, index) => (
    <tr key={"a" + index}>
      <td key={"b" + index}>
        {project.link === undefined ? (
          project.name
        ) : (
          <a href={project.link}>{project.name}</a>
        )}
      </td>
      <td key={"c" + index}>{project.description}</td>
      <td key={"d" + index}>{project.language}</td>
      <td key={"e" + index}>{project.date}</td>
    </tr>
  ));
}

export default function Projects() {
  return (
    <LanguageContext.Consumer>
      {({ language }) => (
        <div id="modal-projects" className="modal">
          <h2>{language.pages.projects.title}</h2>
          <p>{language.pages.projects.description}</p>

          <div>
            <table>
              <tbody>
                <tr>
                  <th>Name</th>
                  <th>{language.pages.projects.tableTh.description}</th>
                  <th>{language.pages.projects.tableTh.language}</th>
                  <th>{language.pages.projects.tableTh.date}</th>
                </tr>

                <RenderProjects language={language} />
              </tbody>
            </table>
          </div>
        </div>
      )}
    </LanguageContext.Consumer>
  );
}
